=== modified file 'debian/changelog'
--- debian/changelog	2010-03-05 04:06:08 +0000
+++ debian/changelog	2010-09-20 18:57:13 +0000
@@ -1,3 +1,10 @@
+coreutils (7.4-2ubuntu3) lucid-proposed; urgency=low
+
+  * Fix "Bad file descriptor" message from cp & touch (ensure that futimens
+    is only called with a valid file descriptor). LP: #552816.
+
+ -- Matthias Klose <doko@ubuntu.com>  Mon, 20 Sep 2010 18:57:13 +0200
+
 coreutils (7.4-2ubuntu2) lucid; urgency=low
 
   * rebuild rest of main for armel armv7/thumb2 optimization;

=== modified file 'debian/patches/00list'
--- debian/patches/00list	2009-05-02 12:28:58 +0000
+++ debian/patches/00list	2010-09-20 18:57:13 +0000
@@ -2,3 +2,4 @@
 63_dd-appenderrors
 72_id_checkngroups
 78_kfbsd_tab.dpatch
+79_futimens.patch

=== added file 'debian/patches/79_futimens.patch'
--- debian/patches/79_futimens.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/79_futimens.patch	2010-09-20 18:57:13 +0000
@@ -0,0 +1,35 @@
+#! /bin/sh /usr/share/dpatch/dpatch-run
+## 79_futimens.dpatch
+##
+## All lines beginning with `## DP:' are a description of the patch.
+## DP: fixes "Bad file descriptor" message from cp & touch.
+
+@DPATCH@
+--- tar-1.22.orig/lib/utimens.c
++++ tar-1.22/lib/utimens.c
+@@ -120,16 +120,17 @@
+     }
+ #endif
+ #if HAVE_FUTIMENS
+-  {
+-    int result = futimens (fd, timespec);
++  if (fd >= 0)
++    {
++      int result = futimens (fd, timespec);
+ # ifdef __linux__
+-    /* Work around the same bug as above.  */
+-    if (0 < result)
+-      errno = ENOSYS;
++      /* Work around the same bug as above.  */
++      if (0 < result)
++        errno = ENOSYS;
+ # endif
+-    if (result == 0 || errno != ENOSYS)
+-      return result;
+-  }
++      if (result == 0 || errno != ENOSYS)
++        return result;
++    }
+ #endif
+ 
+   /* The platform lacks an interface to set file timestamps with

